--- utils.c.orig	2007-04-30 17:22:32.000000000 -0400
+++ utils.c	2007-10-31 15:55:08.000000000 -0400
@@ -496,6 +496,21 @@
 			strcpy(macro_x[MACRO_SERVICESTATE],"UNKNOWN");
 	        }
 
+	/* get the last service state */
+	if(macro_x[MACRO_LASTSERVICESTATE]!=NULL)
+		free(macro_x[MACRO_LASTSERVICESTATE]);
+	macro_x[MACRO_LASTSERVICESTATE]=(char *)malloc(MAX_STATE_LENGTH);
+	if(macro_x[MACRO_LASTSERVICESTATE]!=NULL){
+		if(svc->last_state==STATE_OK)
+			strcpy(macro_x[MACRO_LASTSERVICESTATE],"OK");
+		else if(svc->last_state==STATE_WARNING)
+			strcpy(macro_x[MACRO_LASTSERVICESTATE],"WARNING");
+		else if(svc->last_state==STATE_CRITICAL)
+			strcpy(macro_x[MACRO_LASTSERVICESTATE],"CRITICAL");
+		else
+			strcpy(macro_x[MACRO_LASTSERVICESTATE],"UNKNOWN");
+	        }
+
 	/* get the service state id */
 	if(macro_x[MACRO_SERVICESTATEID]!=NULL)
 		free(macro_x[MACRO_SERVICESTATEID]);
@@ -1542,6 +1557,21 @@
 		        }
 	        }
 
+	/* get the last service state */
+	else if(!strcmp(macro,"LASTSERVICESTATE")){
+		macro_ondemand=(char *)malloc(MAX_STATE_LENGTH);
+		if(macro_ondemand!=NULL){
+			if(svc->last_state==STATE_OK)
+				strcpy(macro_ondemand,"OK");
+			else if(svc->last_state==STATE_WARNING)
+				strcpy(macro_ondemand,"WARNING");
+			else if(svc->last_state==STATE_CRITICAL)
+				strcpy(macro_ondemand,"CRITICAL");
+			else
+				strcpy(macro_ondemand,"UNKNOWN");
+		        }
+	        }
+
 	/* get the service state id */
 	else if(!strcmp(macro,"SERVICESTATEID")){
 		macro_ondemand=(char *)malloc(MAX_STATEID_LENGTH);
@@ -2309,6 +2339,7 @@
 	add_macrox_name(MACRO_TIMET,"TIMET");
 	add_macrox_name(MACRO_LASTHOSTCHECK,"LASTHOSTCHECK");
 	add_macrox_name(MACRO_LASTSERVICECHECK,"LASTSERVICECHECK");
+	add_macrox_name(MACRO_LASTSERVICESTATE,"LASTSERVICESTATE");
 	add_macrox_name(MACRO_LASTHOSTSTATECHANGE,"LASTHOSTSTATECHANGE");
 	add_macrox_name(MACRO_LASTSERVICESTATECHANGE,"LASTSERVICESTATECHANGE");
 	add_macrox_name(MACRO_HOSTOUTPUT,"HOSTOUTPUT");
